import random
import sys

# number_of_lines(f) returns the number of lines in file f
def number_of_lines(filepath):
    fileobj = open(filepath,'r')
    nol = len(fileobj.readlines())
    fileobj.close()
    return nol

# getline(f,n) get the line number n in file f
# line numbering follows the convention of list indexing
def getline(filepath,n):
    fileobj = open(filepath,'r')
    line = fileobj.readlines()[n]
    fileobj.close()
    return line

# update_word(word,blank,c) returns a copy s of blank with s[i]
# replaced by the character c whenever word[i] equals c
# word and blank should be of same length
def update_word(word,blank,c):
    return ''.join([c if word[i]==c else blank[i] for i in range(len(blank))])

# -- main program --
# check there is enough argument
if len(sys.argv) != 2 :
    print "Usage: "+sys.argv[0]+" dictionnary_path"
    exit(0)
# first choose a word and make the blank version of it
dictpath = sys.argv[1]
word = getline(dictpath, random.randint(0,number_of_lines(dictpath)))[:-1]
blank = ''.join(['*' for x in word])

"""The usual hangman has 6 chances before death: 
 - head, 
 - body, 
 - left and right arms, 
 - left and right legs

"""
chances = 6
while chances>0:
    print blank
    guess = raw_input("Take a guess ("+str(chances)+" chances left): ")
    if len(guess)>1:
        if guess == word:
            print "You win!"
            break
        else: chances -= 1
    elif len(guess)==1:
        tmp = update_word(word,blank,guess[0])
        if tmp == blank: chances -= 1
        blank = tmp
        if blank==word or not reduce(lambda x,y: (x or y=='*'),blank,False):
            print "You win!"
            break
    else:
        print "You wasted a chance..."

if chances==0:
    print blank
    print "You lost. The word was: "+word+"."
